using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data;

namespace _2413B
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();


            DataSet ds = new DataSet();
            DataTable parentTable = GetParentTable();
            DataTable childTable = GetChildTable();


            ds.Tables.AddRange(new DataTable[] { parentTable, childTable });

            DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
            ds.Relations.Add(parentToChild);
            //			
            //this.gridDataBoundGrid1.DataSource = ds;
            this.gridDataBoundGrid1.DataSource = parentTable;
            //this.gridDataBoundGrid1.DataMember = parentTable.TableName;

            //set the grids
            //			this.gridDataBoundGrid1.DataSource = parentTable;

            this.gridDataBoundGrid2.DataSource = parentTable;
            this.gridDataBoundGrid2.DataMember = "ParentToChild";
        }


        DataTable GetParentTable()
        {
            DataTable dt = new DataTable("ParentTable");


            dt.Columns.Add(new DataColumn("parentID")); //lower case p
            dt.Columns.Add(new DataColumn("ParentName"));
            dt.Columns.Add(new DataColumn("ParentDec"));

            return dt;
        }

        DataTable GetChildTable()
        {
            DataTable dt = new DataTable("ChildTable");

            dt.Columns.Add(new DataColumn("childID")); //lower case c
            dt.Columns.Add(new DataColumn("Name"));
            dt.Columns.Add(new DataColumn("ParentID")); //upper case P

            return dt;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            this.gridDataBoundGrid1.Binder.ResumeBinding();
            this.timer1.Stop();
        }

        private void gridDataBoundGrid1_CurrentCellRejectedChanges(object sender, EventArgs e)
        {
            this.gridDataBoundGrid1.Binder.SuspendBinding();
            this.timer1.Start();
        }
    }
}